package logwire.core.bo.factory;

import logwire.core.bo.object.BizObject;

public interface BizObjectFactoryHandler<X extends BizObject> {

    String getName();

    // 取消enable这个参数，配置文件和程序里都有配置会导致混淆
    // 只会从配置文件中读取，只有在配置文件中配置的，才会进行加载
   //boolean isEnabled();

    //取消order参数，按照配置文件中的顺序来执行
    //default int getOrder(){return 1000;}

    default boolean accept(Class<X> xClass, Object... args) {
        return true;
    }

    Object execute(Class<X> xClass, Object... args);
}

