package logwire.core.bo.factory;

import logwire.core.bo.annotation.Operation;
import logwire.core.bo.list.BizList;
import logwire.core.bo.object.BizObject;

import java.util.Map;

/**
 * BOFactory默认实现的接口
 * @param <X> BO类
 */
public interface DefaultBizObjectFactory<X extends BizObject> {
    @Operation(name = "create",label="创建BO对象")
    X create();
    @Operation(name = "createByDefault")
    X createByDefault(Map defaultValues);
    @Operation(name = "findById")
    X findById(Long id);
    @Operation(name = "findOne")
    X findOne(Map fields);
    /* 暂不支持lql
    @Operation()
    X find(String query);
    @Operation()
    X find(String query, List fieldValues);
    */
    @Operation(name = "createList")
    BizList<X> createList();
    @Operation(name = "createListByDefault")
    BizList<X> createListByDefault(Map fields);
    @Operation(name = "find")
    BizList<X> find(Map fields);
    /* 暂不支持lql
    @Operation()
    BizList<X> find(String query);
    @Operation()
    BizList<X> find(String query, List fieldValues);
    */
    @Operation(name = "findAll")
    BizList<X> findAll();
    /* 暂不支持lql
    @Operation()
    List<Object> findField(String query, String field);
    @Operation()
    List<Map> findFields(String query, String...fields);
    */
    // 更多Operation
}
