package logwire.core.bo.list;

import logwire.core.bo.annotation.Operation;
import logwire.core.bo.object.BizObject;
import logwire.core.bo.operation.list.DefaultListOperationProvider;

import java.util.Map;

public abstract class BizList<X extends BizObject> implements Iterable<X>,DefaultListOperationProvider<X> {

    @Operation(name = "findById")
    abstract X findById(Long id);

    @Operation(name = "findOne")
    abstract X findOne(String field, Object value);

    @Operation(name = "findOneByMap")
    abstract X findOneByMap(Map fields);

    /* 暂不支持lql
    X find(String query);
    */
    @Operation(name = "create")
    abstract X create();

    @Operation(name = "createByMap")
    abstract X createByMap(Map fields);

    @Operation(name = "find")
    abstract BizList<X> find(String field, Object value);

    @Operation(name = "findByMap")
    abstract BizList<X> findByMap(Map fields);

    /* 暂不支持lql
    BizList<X> find(String query);
     */
    @Operation(name = "findAll")
    abstract BizList<X> findAll();
}